#[doc = "Register `ICER` reader"]
pub struct R(crate::R<ICER_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ICER_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ICER_SPEC>> for R {
    fn from(reader: crate::R<ICER_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ICER` writer"]
pub struct W(crate::W<ICER_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ICER_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ICER_SPEC>> for W {
    fn from(writer: crate::W<ICER_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `CLRENA` writer - Disables, or reads the enabled state of one or more interrupts. Each bit corresponds to the same numbered interrupt."]
pub struct CLRENA_W<'a> {
    w: &'a mut W,
}
impl<'a> CLRENA_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff_ffff) | (value as u32 & 0xffff_ffff);
        self.w
    }
}
impl W {
    #[doc = "Bits 0:31 - Disables, or reads the enabled state of one or more interrupts. Each bit corresponds to the same numbered interrupt."]
    #[inline(always)]
    pub fn clrena(&mut self) -> CLRENA_W {
        CLRENA_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Interrupt Clear Enable Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [icer](index.html) module"]
pub struct ICER_SPEC;
impl crate::RegisterSpec for ICER_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [icer::R](R) reader structure"]
impl crate::Readable for ICER_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [icer::W](W) writer structure"]
impl crate::Writable for ICER_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ICER to value 0"]
impl crate::Resettable for ICER_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
